Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/OoaCompleteAstTraversalVisitor.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/OoaCompleteAstTraversalVisitor.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/OoaCompleteAstTraversalVisitor.java	(revision 9)
@@ -42,7 +42,6 @@
 import org.momut.ooas.ast.expressions.ListConstructor;
 import org.momut.ooas.ast.expressions.MapConstructor;
 import org.momut.ooas.ast.expressions.ObjectConstructor;
-import org.momut.ooas.ast.expressions.QValConstructor;
 import org.momut.ooas.ast.expressions.SetConstructor;
 import org.momut.ooas.ast.expressions.TernaryOperator;
 import org.momut.ooas.ast.expressions.TupleConstructor;
@@ -57,7 +56,6 @@
 import org.momut.ooas.ast.identifiers.EnumIdentifier;
 import org.momut.ooas.ast.identifiers.ExpressionVariableIdentifier;
 import org.momut.ooas.ast.identifiers.Identifier;
-import org.momut.ooas.ast.identifiers.LandmarkIdentifier;
 import org.momut.ooas.ast.identifiers.LocalVariableIdentifier;
 import org.momut.ooas.ast.identifiers.MainModule;
 import org.momut.ooas.ast.identifiers.MethodIdentifier;
@@ -78,7 +76,6 @@
 import org.momut.ooas.ast.statements.KillStatement;
 import org.momut.ooas.ast.statements.NondetBlock;
 import org.momut.ooas.ast.statements.PrioBlock;
-import org.momut.ooas.ast.statements.QualitativeConstraintStatement;
 import org.momut.ooas.ast.statements.SeqBlock;
 import org.momut.ooas.ast.statements.SkipStatement;
 import org.momut.ooas.ast.statements.Statement;
@@ -94,9 +91,8 @@
 import org.momut.ooas.ast.types.NullType;
 import org.momut.ooas.ast.types.OoActionSystemType;
 import org.momut.ooas.ast.types.OpaqueType;
-import org.momut.ooas.ast.types.QrType;
 import org.momut.ooas.ast.types.TupleType;
-import org.momut.ooas.ast.types.UlyssesType;
+import org.momut.ooas.ast.types.Type;
 import org.momut.ooas.parser.ParserState;
 
 public abstract class OoaCompleteAstTraversalVisitor implements IAstVisitor
@@ -122,7 +118,7 @@
 	/// </summary>
 	/// <param name="element">to be visited</param>
 	/// <param name="parent">parent of the element in the ast</param>
-	protected /*virtual*/ void VisitAstElement(IAst element, IAst parent)
+	protected void VisitAstElement(IAst element, IAst parent)
 	{
 		element.Accept(this);
 	}
@@ -155,13 +151,13 @@
 	}
 
 	@Override
-	public /*virtual*/ void visit(EnumIdentifier enumIdentifier)
+	public void visit(EnumIdentifier enumIdentifier)
 	{
 		VisitSub(enumIdentifier.type(), enumIdentifier);
 	}
 
 	@Override
-	public /*virtual*/ void visit(ConstantIdentifier constantIdentifier)
+	public void visit(ConstantIdentifier constantIdentifier)
 	{
 		if (constantIdentifier.type() != null)
 			VisitSub(constantIdentifier.type(), constantIdentifier);
@@ -168,52 +164,45 @@
 		VisitSub(constantIdentifier.Value(), constantIdentifier);
 	}
 
-
 	@Override
-	public /*virtual*/ void visit(LandmarkIdentifier landmarkIdentifier)
+	public void visit(AttributeIdentifier attributeIdentifier)
 	{
-		VisitSub(landmarkIdentifier.type(), landmarkIdentifier);
-	}
-
-	@Override
-	public /*virtual*/ void visit(AttributeIdentifier attributeIdentifier)
-	{
 		VisitSub(attributeIdentifier.type(), attributeIdentifier);
 		VisitSub(attributeIdentifier.initializer(), attributeIdentifier);
 	}
 
 	@Override
-	public /*virtual*/ void visit(ExpressionVariableIdentifier expressionVariableIdentifier)
+	public void visit(ExpressionVariableIdentifier expressionVariableIdentifier)
 	{
 		VisitSub(expressionVariableIdentifier.type(), expressionVariableIdentifier);
 	}
 
 	@Override
-	public /*virtual*/ void visit(ParameterIdentifier parameterIdentifier)
+	public void visit(ParameterIdentifier parameterIdentifier)
 	{
 		VisitSub(parameterIdentifier.type(), parameterIdentifier);
 	}
 
 	@Override
-	public /*virtual*/ void visit(LocalVariableIdentifier localVariableIdentifier)
+	public void visit(LocalVariableIdentifier localVariableIdentifier)
 	{
 		VisitSub(localVariableIdentifier.type(), localVariableIdentifier);
 	}
 
 	@Override
-	public /*virtual*/ void visit(TypeIdentifier typeIdentifier)
+	public void visit(TypeIdentifier typeIdentifier)
 	{
 		VisitSub(typeIdentifier.type(), typeIdentifier);
 	}
 
 	@Override
-	public /*virtual*/ void visit(SelfTypeIdentifier aself)
+	public void visit(SelfTypeIdentifier aself)
 	{
 		visit((TypeIdentifier)aself);
 	}
 
 	@Override
-	public /*virtual*/ void visit(MethodIdentifier methodIdentifier)
+	public void visit(MethodIdentifier methodIdentifier)
 	{
 		VisitSub(methodIdentifier.type(), methodIdentifier);
 		for (final Identifier sym: methodIdentifier.symbolTable().symbolList())
@@ -224,7 +213,7 @@
 	}
 
 	@Override
-	public /*virtual*/ void visit(NamedActionIdentifier namedActionIdentifier)
+	public void visit(NamedActionIdentifier namedActionIdentifier)
 	{
 		VisitSub(namedActionIdentifier.type(), namedActionIdentifier);
 		for (final Identifier sym : namedActionIdentifier.symbolTable().symbolList())
@@ -235,7 +224,7 @@
 	}
 
 	@Override
-	public /*virtual*/ void visit(MainModule mainModule)
+	public void visit(MainModule mainModule)
 	{
 		for (final Identifier sym: mainModule.symbolTable().symbolList())
 			VisitSub(sym, mainModule);
@@ -247,7 +236,7 @@
 	}
 
 	@Override
-	public /*virtual*/ void visit(Module module)
+	public void visit(Module module)
 	{
 		for (final Identifier sym: module.symbolTable().symbolList())
 			VisitSub(sym, module);
@@ -254,7 +243,7 @@
 	}
 
 	@Override
-	public /*virtual*/ void visit(NondetIdentifierList nondetIdentifierList)
+	public void visit(NondetIdentifierList nondetIdentifierList)
 	{
 		for (final Identifier id: nondetIdentifierList.identifiers())
 			VisitSub(id, nondetIdentifierList);
@@ -261,7 +250,7 @@
 	}
 
 	@Override
-	public /*virtual*/ void visit(SeqIdentifierList seqIdentifierList)
+	public void visit(SeqIdentifierList seqIdentifierList)
 	{
 		for (final Identifier id: seqIdentifierList.identifiers())
 			VisitSub(id, seqIdentifierList);
@@ -268,7 +257,7 @@
 	}
 
 	@Override
-	public /*virtual*/ void visit(PrioIdentifierList prioIdentifierList)
+	public void visit(PrioIdentifierList prioIdentifierList)
 	{
 		for (final Identifier id: prioIdentifierList.identifiers())
 			VisitSub(id, prioIdentifierList);
@@ -275,7 +264,7 @@
 	}
 
 	@Override
-	public /*virtual*/ void visit(UnspecIdentifierList unspecIdentifierList)
+	public void visit(UnspecIdentifierList unspecIdentifierList)
 	{
 		for (final Identifier id: unspecIdentifierList.identifiers())
 			VisitSub(id, unspecIdentifierList);
@@ -282,7 +271,7 @@
 	}
 
 	@Override
-	public /*virtual*/ void visit(NondetBlock nondetBlock)
+	public void visit(NondetBlock nondetBlock)
 	{
 		for (final Identifier id: nondetBlock.symbols().symbolList())
 			VisitSub(id, nondetBlock);
@@ -292,7 +281,7 @@
 	}
 
 	@Override
-	public /*virtual*/ void visit(SeqBlock seqBlock)
+	public void visit(SeqBlock seqBlock)
 	{
 		for (final Identifier id: seqBlock.symbols().symbolList())
 			VisitSub(id, seqBlock);
@@ -305,7 +294,7 @@
 	}
 
 	@Override
-	public /*virtual*/ void visit(PrioBlock prioBlock)
+	public void visit(PrioBlock prioBlock)
 	{
 		for (final Identifier id: prioBlock.symbols().symbolList())
 			VisitSub(id, prioBlock);
@@ -315,7 +304,7 @@
 	}
 
 	@Override
-	public /*virtual*/ void visit(GuardedCommand guardedCommand)
+	public void visit(GuardedCommand guardedCommand)
 	{
 		VisitSub(guardedCommand.guard(), guardedCommand);
 		VisitSub(guardedCommand.body(), guardedCommand);
@@ -322,7 +311,7 @@
 	}
 
 	@Override
-	public /*virtual*/ void visit(Assignment assignment)
+	public void visit(Assignment assignment)
 	{
 		for (final Expression vexp: assignment.places())
 			VisitSub(vexp, assignment);
@@ -333,13 +322,13 @@
 	}
 
 	@Override
-	public /*virtual*/ void visit(Call call)
+	public void visit(Call call)
 	{
 		VisitSub(call.callExpression(), call);
 	}
 
 	@Override
-	public /*virtual*/ void visit(SkipStatement skipStatement)
+	public void visit(SkipStatement skipStatement)
 	{ }
 
 	@Override
@@ -347,27 +336,27 @@
 	{ }
 
 	@Override
-	public /*virtual*/ void visit(AbortStatement abortStatement)
+	public void visit(AbortStatement abortStatement)
 	{ }
 
 	@Override
-	public /*virtual*/ void visit(KillStatement killStatement)
+	public void visit(KillStatement killStatement)
 	{
 		VisitSub(killStatement.someOne, killStatement);
 	}
 
 	@Override
-	public /*virtual*/ <T>void visit(ValueExpression<T> valueExpression)
+	public <T>void visit(ValueExpression<T> valueExpression)
 	{ }
 
 	@Override
-	public /*virtual*/ void visit(UnresolvedIdentifierExpression unresolvedIdentifierExpression)
+	public void visit(UnresolvedIdentifierExpression unresolvedIdentifierExpression)
 	{
 		VisitSub(unresolvedIdentifierExpression.type(), unresolvedIdentifierExpression);
 	}
 
 	@Override
-	public /*virtual*/ void visit(IdentifierExpression identifierExpression)
+	public void visit(IdentifierExpression identifierExpression)
 	{
 		VisitSub(identifierExpression.type(), identifierExpression);
 		VisitSub(identifierExpression.identifier(), identifierExpression);
@@ -374,13 +363,13 @@
 	}
 
 	@Override
-	public /*virtual*/ void visit(TypeExpression typeExpression)
+	public void visit(TypeExpression typeExpression)
 	{
 		VisitSub(typeExpression.type(), typeExpression);
 	}
 
 	@Override
-	public /*virtual*/ void visit(ListConstructor listConstructor)
+	public void visit(ListConstructor listConstructor)
 	{
 		for (final Identifier lvar: listConstructor.comprehensionVariables().symbolList())
 			VisitSub(lvar, listConstructor);
@@ -393,7 +382,7 @@
 	}
 
 	@Override
-	public /*virtual*/ void visit(SetConstructor setConstructor)
+	public void visit(SetConstructor setConstructor)
 	{
 		for (final Identifier svar: setConstructor.comprehensionVariables().symbolList())
 			VisitSub(svar, setConstructor);
@@ -405,7 +394,7 @@
 	}
 
 	@Override
-	public /*virtual*/ void visit(MapConstructor mapConstructor)
+	public void visit(MapConstructor mapConstructor)
 	{
 		/*foreach (var lvar in mapConstructor.localVariables.symbolList)
 			VisitSub(lvar, mapConstructor);*/
@@ -418,7 +407,7 @@
 	}
 
 	@Override
-	public /*virtual*/ void visit(TupleConstructor tupleConstructor)
+	public void visit(TupleConstructor tupleConstructor)
 	{
 		/*foreach (var lvar in tupleConstructor.localVariables.symbolList)
 			VisitSub(lvar, tupleConstructor);*/
@@ -428,7 +417,7 @@
 	}
 
 	@Override
-	public /*virtual*/ void visit(AccessExpression accessExpression)
+	public void visit(AccessExpression accessExpression)
 	{
 		VisitSub(accessExpression.left(), accessExpression);
 		VisitSub(accessExpression.right(), accessExpression);
@@ -435,7 +424,7 @@
 	}
 
 	@Override
-	public /*virtual*/ void visit(BinaryOperator binaryOperator)
+	public void visit(BinaryOperator binaryOperator)
 	{
 		VisitSub(binaryOperator.left(), binaryOperator);
 		VisitSub(binaryOperator.right(), binaryOperator);
@@ -442,7 +431,7 @@
 	}
 
 	@Override
-	public /*virtual*/ void visit(TernaryOperator ternaryOperator)
+	public void visit(TernaryOperator ternaryOperator)
 	{
 		VisitSub(ternaryOperator.left(), ternaryOperator);
 		VisitSub(ternaryOperator.mid(), ternaryOperator);
@@ -450,7 +439,7 @@
 	}
 
 	@Override
-	public /*virtual*/ void visit(TupleMapAccessExpression tupleMapAccessExpression)
+	public void visit(TupleMapAccessExpression tupleMapAccessExpression)
 	{
 		VisitSub(tupleMapAccessExpression.argument(), tupleMapAccessExpression);
 		VisitSub(tupleMapAccessExpression.child(), tupleMapAccessExpression);
@@ -457,7 +446,7 @@
 	}
 
 	@Override
-	public /*virtual*/ void visit(CallExpression callExpression)
+	public void visit(CallExpression callExpression)
 	{
 		if (callExpression.arguments() != null)
 			for (final Expression arg: callExpression.arguments())
@@ -466,7 +455,7 @@
 	}
 
 	@Override
-	public /*virtual*/ void visit(ForallQuantifier quantifier)
+	public void visit(ForallQuantifier quantifier)
 	{
 		for (final Identifier lvar: quantifier.symbols().symbolList())
 			VisitSub(lvar, quantifier);
@@ -475,7 +464,7 @@
 	}
 
 	@Override
-	public /*virtual*/ void visit(ExistsQuantifier quantifier)
+	public void visit(ExistsQuantifier quantifier)
 	{
 		for (final Identifier lvar: quantifier.symbols().symbolList())
 			VisitSub(lvar, quantifier);
@@ -484,7 +473,7 @@
 	}
 
 	@Override
-	public /*virtual*/ void visit(UnaryOperator unaryOperator)
+	public void visit(UnaryOperator unaryOperator)
 	{
 		VisitSub(unaryOperator.child(), unaryOperator);
 		if (unaryOperator.kind() == ExpressionKind.Cast)
@@ -494,27 +483,27 @@
 
 
 	@Override
-	public /*virtual*/ void visit(CharType charType)
+	public void visit(CharType charType)
 	{
 	}
 
 	@Override
-	public /*virtual*/ void visit(IntType intType)
+	public void visit(IntType intType)
 	{
 	}
 
 	@Override
-	public /*virtual*/ void visit(BoolType boolType)
+	public void visit(BoolType boolType)
 	{
 	}
 
 	@Override
-	public /*virtual*/ void visit(FloatType floatType)
+	public void visit(FloatType floatType)
 	{
 	}
 
 	@Override
-	public /*virtual*/ void visit(EnumType enumType)
+	public void visit(EnumType enumType)
 	{
 		for (final Identifier sym: enumType.listOfEnumSymbols())
 			VisitSub(sym, enumType);
@@ -521,13 +510,13 @@
 	}
 
 	@Override
-	public /*virtual*/ void visit(ListType listType)
+	public void visit(ListType listType)
 	{
 		VisitSub(listType.innerType(), listType);
 	}
 
 	@Override
-	public /*virtual*/ void visit(MapType mapType)
+	public void visit(MapType mapType)
 	{
 		VisitSub(mapType.fromType(), mapType);
 		VisitSub(mapType.toType(), mapType);
@@ -534,29 +523,22 @@
 	}
 
 	@Override
-	public /*virtual*/ void visit(QrType qrType)
+	public void visit(TupleType tupleType)
 	{
-		for (final Identifier m: qrType.landmarks())
-			VisitSub(m, qrType);
-	}
-
-	@Override
-	public /*virtual*/ void visit(TupleType tupleType)
-	{
-		for (final UlyssesType t: tupleType.innerTypes())
+		for (final Type t: tupleType.innerTypes())
 			VisitSub(t, tupleType);
 	}
 
 	@Override
-	public /*virtual*/ void visit(FunctionType functionType)
+	public void visit(FunctionType functionType)
 	{
-		for (final UlyssesType a: functionType.parameter())
+		for (final Type a: functionType.parameter())
 			VisitSub(a, functionType);
 		VisitSub(functionType.returnType(), functionType);
 	}
 
 	@Override
-	public /*virtual*/ void visit(OoActionSystemType ooActionSystemType)
+	public void visit(OoActionSystemType ooActionSystemType)
 	{
 		for (final Identifier s: ooActionSystemType.symbols().symbolList())
 			VisitSub(s, ooActionSystemType);
@@ -564,7 +546,7 @@
 		VisitSub(ooActionSystemType.doOdBlock(), ooActionSystemType);
 	}
 
-	public /*virtual*/ @Override
+	public @Override
 	void visit(OpaqueType opaqueType)
 	{
 		VisitSub(opaqueType.resolvedType(), opaqueType);
@@ -571,31 +553,17 @@
 	}
 
 	@Override
-	public /*virtual*/ void visit(NullType nullType)
+	public void visit(NullType nullType)
 	{ }
 
 	@Override
-	public /*virtual*/ void visit(AnyType anyType)
+	public void visit(AnyType anyType)
 	{ }
 
 	@Override
-	public /*virtual*/ void visit(ObjectConstructor objectConstructor)
+	public void visit(ObjectConstructor objectConstructor)
 	{
 		VisitSub(objectConstructor.type(), objectConstructor);
 	}
-
-	@Override
-	public /*virtual*/ void visit(QValConstructor qValConstructor)
-	{
-	}
-
-	@Override
-	public /*virtual*/ void visit(QualitativeConstraintStatement qalitativeConstraintStatement)
-	{
-		VisitSub(qalitativeConstraintStatement.variable0(), qalitativeConstraintStatement);
-		VisitSub(qalitativeConstraintStatement.variable1(), qalitativeConstraintStatement);
-		if (qalitativeConstraintStatement.variable2() != null)
-			VisitSub(qalitativeConstraintStatement.variable2(), qalitativeConstraintStatement);
-	}
 }
 
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/OoaActionClassifierVisitor.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/OoaActionClassifierVisitor.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/OoaActionClassifierVisitor.java	(revision 9)
@@ -199,9 +199,6 @@
 			case Skip:
 			case Break:
 				break;
-			case QualConstraint:
-				w.m_hasUnsafeElement = true;
-				break;
 			case SeqBlock:
 				// seq block in seq block should not occur..
 			default:
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/OoaDeepCloneVisitor.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/OoaDeepCloneVisitor.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/OoaDeepCloneVisitor.java	(revision 9)
@@ -28,7 +28,6 @@
 package org.momut.ooas.visitors;
 
 import java.util.ArrayList;
-import java.util.Arrays;
 import java.util.HashMap;
 import java.util.List;
 import java.util.ListIterator;
@@ -44,7 +43,6 @@
 import org.momut.ooas.ast.expressions.ListConstructor;
 import org.momut.ooas.ast.expressions.MapConstructor;
 import org.momut.ooas.ast.expressions.ObjectConstructor;
-import org.momut.ooas.ast.expressions.QValConstructor;
 import org.momut.ooas.ast.expressions.Quantifier;
 import org.momut.ooas.ast.expressions.SetConstructor;
 import org.momut.ooas.ast.expressions.TernaryOperator;
@@ -59,7 +57,6 @@
 import org.momut.ooas.ast.identifiers.ExpressionVariableIdentifier;
 import org.momut.ooas.ast.identifiers.Identifier;
 import org.momut.ooas.ast.identifiers.IdentifierKind;
-import org.momut.ooas.ast.identifiers.LandmarkIdentifier;
 import org.momut.ooas.ast.identifiers.LocalVariableIdentifier;
 import org.momut.ooas.ast.identifiers.MainModule;
 import org.momut.ooas.ast.identifiers.MethodIdentifier;
@@ -79,7 +76,6 @@
 import org.momut.ooas.ast.statements.KillStatement;
 import org.momut.ooas.ast.statements.NondetBlock;
 import org.momut.ooas.ast.statements.PrioBlock;
-import org.momut.ooas.ast.statements.QualitativeConstraintStatement;
 import org.momut.ooas.ast.statements.SeqBlock;
 import org.momut.ooas.ast.statements.SkipStatement;
 import org.momut.ooas.ast.statements.Statement;
@@ -95,7 +91,6 @@
 import org.momut.ooas.ast.types.NullType;
 import org.momut.ooas.ast.types.OoActionSystemType;
 import org.momut.ooas.ast.types.OpaqueType;
-import org.momut.ooas.ast.types.QrType;
 import org.momut.ooas.ast.types.TupleType;
 import org.momut.ooas.parser.SymbolTable;
 import org.momut.ooas.utils.OoasCompilerHashMap;
@@ -113,60 +108,57 @@
 
 	/* we do not clone types */
 	@Override
-	public /*override*/ void visit(AnyType anyType)
+	public void visit(AnyType anyType)
 	{ throw new NotImplementedException(); }
 	@Override
-	public /*override*/ void visit(BoolType boolType)
+	public void visit(BoolType boolType)
 	{ throw new NotImplementedException(); }
 	@Override
-	public /*override*/ void visit(CharType charType)
+	public void visit(CharType charType)
 	{ throw new NotImplementedException(); }
 	@Override
-	public /*override*/ void visit(EnumType enumType)
+	public void visit(EnumType enumType)
 	{ throw new NotImplementedException(); }
 	@Override
-	public /*override*/ void visit(FloatType floatType)
+	public void visit(FloatType floatType)
 	{ throw new NotImplementedException(); }
 	@Override
-	public /*override*/ void visit(FunctionType functionType)
+	public void visit(FunctionType functionType)
 	{ throw new NotImplementedException(); }
 	@Override
-	public /*override*/ void visit(IntType intType)
+	public void visit(IntType intType)
 	{ throw new NotImplementedException(); }
 	@Override
-	public /*override*/ void visit(ListType listType)
+	public void visit(ListType listType)
 	{ throw new NotImplementedException(); }
 	@Override
-	public /*override*/ void visit(MapType mapType)
+	public void visit(MapType mapType)
 	{ throw new NotImplementedException(); }
 	@Override
-	public /*override*/ void visit(NullType nullType)
+	public void visit(NullType nullType)
 	{ throw new NotImplementedException(); }
 	@Override
-	public /*override*/ void visit(OoActionSystemType ooActionSystemType)
+	public void visit(OoActionSystemType ooActionSystemType)
 	{ throw new NotImplementedException(); }
 	@Override
-	public /*override*/ void visit(TupleType tupleType)
+	public void visit(TupleType tupleType)
 	{ throw new NotImplementedException(); }
 	@Override
-	public /*override*/ void visit(EnumIdentifier enumIdentifier)
+	public void visit(EnumIdentifier enumIdentifier)
 	{ throw new NotImplementedException(); }
 	@Override
-	public /*override*/ void visit(LandmarkIdentifier landmarkIdentifier)
+	public void visit(ExpressionVariableIdentifier expressionVariableIdentifier)
 	{ throw new NotImplementedException(); }
-	@Override
-	public /*override*/ void visit(ExpressionVariableIdentifier expressionVariableIdentifier)
-	{ throw new NotImplementedException(); }
 
 
 	@Override
-	public /*override*/ void visit(LocalVariableIdentifier localVariableIdentifier)
+	public void visit(LocalVariableIdentifier localVariableIdentifier)
 	{
 		throw new NotImplementedException();
 	}
 
 	@Override
-	public /*override*/ void visit(MainModule mainModule)
+	public void visit(MainModule mainModule)
 	{
 		throw new NotImplementedException();
 	}
@@ -173,19 +165,19 @@
 
 
 	@Override
-	public /*override*/ void visit(MapConstructor mapConstructor)
+	public void visit(MapConstructor mapConstructor)
 	{
 		throw new NotImplementedException();
 	}
 
 	@Override
-	public /*override*/ void visit(MethodIdentifier methodIdentifier)
+	public void visit(MethodIdentifier methodIdentifier)
 	{
 		throw new NotImplementedException();
 	}
 
 	@Override
-	public /*override*/ void visit(NamedActionIdentifier namedActionIdentifier)
+	public void visit(NamedActionIdentifier namedActionIdentifier)
 	{
 		final Statement newBlock = SClone(namedActionIdentifier.body());
 		namedActionIdentifier.SetBody(newBlock);
@@ -193,13 +185,13 @@
 	}
 
 	@Override
-	public /*override*/ void visit(Module module)
+	public void visit(Module module)
 	{
 		throw new NotImplementedException();
 	}
 
 	@Override
-	public /*override*/ void visit(NondetIdentifierList nondetIdentifierList)
+	public void visit(NondetIdentifierList nondetIdentifierList)
 	{
 		throw new NotImplementedException();
 	}
@@ -206,34 +198,26 @@
 
 
 	@Override
-	public /*override*/ void visit(OpaqueType opaqueType)
+	public void visit(OpaqueType opaqueType)
 	{
 		throw new NotImplementedException(); // must not happen
 	}
 
 	@Override
-	public /*override*/ void visit(ParameterIdentifier parameterIdentifier)
+	public void visit(ParameterIdentifier parameterIdentifier)
 	{
 		throw new NotImplementedException();
 	}
 
 	@Override
-	public /*override*/ void visit(PrioIdentifierList prioIdentifierList)
+	public void visit(PrioIdentifierList prioIdentifierList)
 	{
 		throw new NotImplementedException();
 	}
 
 	@Override
-	public /*override*/ void visit(QrType qrType)
+	public void visit(ObjectConstructor objectConstructor)
 	{
-		throw new NotImplementedException();
-	}
-
-
-
-	@Override
-	public /*override*/ void visit(ObjectConstructor objectConstructor)
-	{
 		//base.visit(objectConstructor);
 	}
 
@@ -325,10 +309,10 @@
 
 	/*no need to clone leafs (they are already cloned and a shallow copy is sufficient*/
 	@Override
-	public /*override*/ void visit(AbortStatement abortStatement)
+	public void visit(AbortStatement abortStatement)
 	{ }
 	@Override
-	public /*override*/ <T> void visit(ValueExpression<T> valueExpression)
+	public <T> void visit(ValueExpression<T> valueExpression)
 	{ }
 
 
@@ -345,29 +329,29 @@
 		}
 	}
 	@Override
-	public /*override*/ void visit(NondetBlock nondetBlock)
+	public void visit(NondetBlock nondetBlock)
 	{
 		cloneBlock(nondetBlock);
 	}
 	@Override
-	public /*override*/ void visit(SeqBlock seqBlock)
+	public void visit(SeqBlock seqBlock)
 	{
 		seqBlock.SetFilter(EClone(seqBlock.filter()));
 		cloneBlock(seqBlock);
 	}
 	@Override
-	public /*override*/ void visit(PrioBlock prioBlock)
+	public void visit(PrioBlock prioBlock)
 	{
 		cloneBlock(prioBlock);
 	}
 
 	@Override
-	public /*override*/ void visit(AccessExpression accessExpression)
+	public void visit(AccessExpression accessExpression)
 	{
 		visit((BinaryOperator)accessExpression);
 	}
 	@Override
-	public /*override*/ void visit(BinaryOperator binaryOperator)
+	public void visit(BinaryOperator binaryOperator)
 	{
 		final Expression left = EClone(binaryOperator.left());
 		final Expression right = EClone(binaryOperator.right());
@@ -376,7 +360,7 @@
 	}
 
 	@Override
-	public /*override*/ void visit(Assignment assignment)
+	public void visit(Assignment assignment)
 	{
 		SymTabClone(assignment.symbols());
 		cloneExpressionList(assignment.places().listIterator());
@@ -386,13 +370,13 @@
 	}
 
 	@Override
-	public /*override*/ void visit(AttributeIdentifier attributeIdentifier)
+	public void visit(AttributeIdentifier attributeIdentifier)
 	{
 		final Expression initializer = EClone(attributeIdentifier.initializer());
 		attributeIdentifier.SetInitializer(initializer);
 	}
 	@Override
-	public /*override*/ void visit(Call call)
+	public void visit(Call call)
 	{
 		final Expression cExpr = EClone(call.callExpression());
 		call.SetCallExpression(cExpr);
@@ -399,7 +383,7 @@
 	}
 
 	@Override
-	public /*override*/ void visit(CallExpression callExpression)
+	public void visit(CallExpression callExpression)
 	{
 		final ArrayList<Expression> newargs = new ArrayList<Expression>();
 		for (final Expression x: callExpression.arguments())
@@ -420,12 +404,12 @@
 		quantifierState = oldQunatifierState;
 	}
 	@Override
-	public /*override*/ void visit(ExistsQuantifier quantifier)
+	public void visit(ExistsQuantifier quantifier)
 	{
 		CloneQuantifier(quantifier);
 	}
 	@Override
-	public /*override*/ void visit(ForallQuantifier quantifier)
+	public void visit(ForallQuantifier quantifier)
 	{
 		CloneQuantifier(quantifier);
 	}
@@ -434,7 +418,7 @@
 
 
 	@Override
-	public /*override*/ void visit(GuardedCommand guardedCommand)
+	public void visit(GuardedCommand guardedCommand)
 	{
 		final Statement newblock = SClone(guardedCommand.body());
 		final Expression newguard = EClone(guardedCommand.guard());
@@ -443,40 +427,22 @@
 	}
 
 	@Override
-	public /*override*/ void visit(IdentifierExpression identifierExpression)
+	public void visit(IdentifierExpression identifierExpression)
 	{
 
 		if (identifierExpression.isSelf())
-		{
-			/*if (quantifierState) //FIXXME
-            {
-                if (!selfreplacement.tokenText.StartsWith("attr"))
-                {
-                    String oldTokenText = selfreplacement.tokenText;
-                    selfreplacement.SetTokenText("attr____model_root_" + selfreplacement.tokenText);
-                    identifierExpression.SetIdentifier(selfreplacement);
-                    selfreplacement.SetTokenText(oldTokenText);
-                }
-            }
-            else
-			 */
 			identifierExpression.SetIdentifier(selfreplacement);
-
-
-		}
 		else if (mapping.containsKey(identifierExpression.identifier())
 				&& identifierExpression.identifier().kind() != IdentifierKind.MethodIdentifier)
-
 			/* we do NOT replace method calls here, since they are prefixed by self if it's a
 			 * method in the current object or by some field/method access if it's another
 			 * object.
 			 */
 			identifierExpression.SetIdentifier((Identifier)mapping.get(identifierExpression.identifier()));
-
 	}
 
 	@Override
-	public /*override*/ void visit(KillStatement killStatement)
+	public void visit(KillStatement killStatement)
 	{
 		if (mapping.containsKey(killStatement.someOne))
 			killStatement.SetIdentifier((Identifier)mapping.get(killStatement.someOne));
@@ -484,7 +450,7 @@
 
 
 	@Override
-	public /*override*/ void visit(ListConstructor listConstructor)
+	public void visit(ListConstructor listConstructor)
 	{
 		SymTabClone(listConstructor.comprehensionVariables());
 
@@ -497,34 +463,14 @@
 	}
 
 	@Override
-	public /*override*/ void visit(QualitativeConstraintStatement qalitativeConstraintStatement)
+	public void visit(SeqIdentifierList seqIdentifierList)
 	{
-		if (qalitativeConstraintStatement.variable0() != null && mapping.containsKey(qalitativeConstraintStatement.variable0()))
-			qalitativeConstraintStatement.SetVariable0((Identifier)mapping.get(qalitativeConstraintStatement.variable0()));
-		if (qalitativeConstraintStatement.variable1() != null && mapping.containsKey(qalitativeConstraintStatement.variable1()))
-			qalitativeConstraintStatement.SetVariable1((Identifier)mapping.get(qalitativeConstraintStatement.variable1()));
-		if (qalitativeConstraintStatement.variable2() != null && mapping.containsKey(qalitativeConstraintStatement.variable2()))
-			qalitativeConstraintStatement.SetVariable2((Identifier)mapping.get(qalitativeConstraintStatement.variable2()));
-	}
-
-
-	@Override
-	public /*override*/ void visit(QValConstructor qValConstructor)
-	{
-		final List<Expression> values = Arrays.asList(qValConstructor.value());
-		for (int i = 0; i < values.size(); i++)
-			qValConstructor.value()[i] = EClone(values.get(i));
-	}
-
-	@Override
-	public /*override*/ void visit(SeqIdentifierList seqIdentifierList)
-	{
 		throw new NotImplementedException();
 	}
 
 
 	@Override
-	public /*override*/ void visit(SetConstructor setConstructor)
+	public void visit(SetConstructor setConstructor)
 	{
 		SymTabClone(setConstructor.comprehensionVariables());
 		final ArrayList<Expression> newelems = new ArrayList<Expression>();
@@ -537,11 +483,11 @@
 
 
 	@Override
-	public /*override*/ void visit(SkipStatement skipStatement)
+	public void visit(SkipStatement skipStatement)
 	{ }
 
 	@Override
-	public /*override*/ void visit(TernaryOperator ternaryOperator)
+	public void visit(TernaryOperator ternaryOperator)
 	{
 		ternaryOperator.SetLeftChild(EClone(ternaryOperator.left()));
 		ternaryOperator.SetMidChild(EClone(ternaryOperator.mid()));
@@ -549,7 +495,7 @@
 	}
 
 	@Override
-	public /*override*/ void visit(TupleConstructor tupleConstructor)
+	public void visit(TupleConstructor tupleConstructor)
 	{
 		final ArrayList<Expression> values = new ArrayList<Expression>();
 		for (final Expression x: tupleConstructor.values())
@@ -558,7 +504,7 @@
 	}
 
 	@Override
-	public /*override*/ void visit(TupleMapAccessExpression tupleMapAccessExpression)
+	public void visit(TupleMapAccessExpression tupleMapAccessExpression)
 	{
 		tupleMapAccessExpression.SetArgument(EClone(tupleMapAccessExpression.argument()));
 		visit((UnaryOperator)tupleMapAccessExpression);
@@ -565,18 +511,18 @@
 	}
 
 	@Override
-	public /*override*/ void visit(TypeExpression typeExpression)
+	public void visit(TypeExpression typeExpression)
 	{ /*we do not clone types*/ }
 
 
 	@Override
-	public /*override*/ void visit(TypeIdentifier typeIdentifier)
+	public void visit(TypeIdentifier typeIdentifier)
 	{
 		throw new NotImplementedException();
 	}
 
 	@Override
-	public /*override*/ void visit(UnaryOperator unaryOperator)
+	public void visit(UnaryOperator unaryOperator)
 	{
 		final Expression child = EClone(unaryOperator.child());
 		unaryOperator.SetChild(child);
@@ -584,13 +530,13 @@
 
 
 	@Override
-	public /*override*/ void visit(UnresolvedIdentifierExpression unresolvedIdentifierExpression)
+	public void visit(UnresolvedIdentifierExpression unresolvedIdentifierExpression)
 	{
 		throw new NotImplementedException(); // must not occur
 	}
 
 	@Override
-	public /*override*/ void visit(UnspecIdentifierList unspecIdentifierList)
+	public void visit(UnspecIdentifierList unspecIdentifierList)
 	{
 		throw new NotImplementedException();
 	}
